unit SocketHeaders;

interface

type
  WordArray = ^TWordArray;
  TWordArray = array [0..0] of Word;

type
  PIPhdr = ^TIPhdr;
  TIPhdr = packed record
    ip_verlen : byte;
    ip_tos    : byte;
    ip_len    : word;
    ip_id     : word;
    ip_off    : word;
    ip_ttl    : byte;
    ip_p      : byte;
    ip_sum    : word;
    ip_src    : longword;
    ip_dst    : longword;
  end;

type
  PICMPhdr = ^TICMPhdr;
  TICMPhdr = packed record
    icmp_type : byte;
    icmp_code : byte;
    icmp_sum  : word;
    icmp_id   : word;
    icmp_seq  : word;
  end;

type
  PTCPhdr = ^TTCPhdr;
  TTCPhdr = packed record
    tcp_src: word;
    tcp_dst: word;
    tcp_seq: longword;
  end;

function CheckSum(Data: WordArray; Size: Integer): Word;

implementation

function CheckSum(Data: WordArray; Size: Integer): Word;
var
  i, Sum: Integer;
begin
  Sum:=0;
  i:=0;
  while (Size > 1) do begin
    Sum:=Sum + Data^[i];
    Dec(Size, 2);
    Inc(i);
  end;
  if (Size <> 0) then Sum:=Sum + Data^[i];
  Sum:=(Sum shr 16) + (Sum and $ffff);
  Sum:=Sum + (Sum shr 16);
  Result:=not Word(Sum);
end;

end.
 