unit SysUtils2;

interface

  function StrtoInt(const S: string): Integer;
  function InttoStr(Value: Integer): string;
  function lint(S: string): Integer;
  function Trim(const S: string): string;
  function StrToIntDef(const S: string; Default: Integer): Integer;
  function LowerCase(const S: string): string;
  function AllocMem(Size: Cardinal): Pointer;
  function ExtractFileName(S: string): string;

implementation

function StrtoInt(const S: string): Integer;
var
  E: Integer;
begin
  Val(S, Result, E);
end;

function InttoStr(Value: Integer): string;
var
  S: string[11];
begin
  Str(Value, S);
  Result:=S;
end;

function lint(S: string): Integer;
var
  i: Integer;
begin
  Result:=0;
  if Length(S) > 0 then if S[1] = ' ' then Delete(S, 1, 1);
  if not (Length(S) > 0) then Exit;
  for i:=1 to Length(S) do
    if not (S[1] in ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9']) then Break;
  Delete(S, i, Length(s)-(i-1));
  Result:=StrtoInt(S);
end;

function Trim(const S: string): string;
var
  I, L: Integer;
begin
  L := Length(S);
  I := 1;
  while (I <= L) and (S[I] <= ' ') do Inc(I);
  if I > L then Result := '' else
  begin
    while S[L] <= ' ' do Dec(L);
    Result := Copy(S, I, L - I + 1);
  end;
end;

function StrToIntDef(const S: string; Default: Integer): Integer;
var
  E: Integer;
begin
  Val(S, Result, E);
  if E <> 0 then Result := Default;
end;

function LowerCase(const S: string): string;
var
  Ch: Char;
  L: Integer;
  Source, Dest: PChar;
begin
  L := Length(S);
  SetLength(Result, L);
  Source := Pointer(S);
  Dest := Pointer(Result);
  while L <> 0 do
  begin
    Ch := Source^;
    if (Ch >= 'A') and (Ch <= 'Z') then Inc(Ch, 32);
    Dest^ := Ch;
    Inc(Source);
    Inc(Dest);
    Dec(L);
  end;
end;

function AllocMem(Size: Cardinal): Pointer;
begin
  GetMem(Result, Size);
  FillChar(Result^, Size, 0);
end;

function ExtractFileName(S: string): string;
var
  i: Integer;
begin
  for i:=Length(S) downto 1 do if S[i] = '\' then Break;
  Delete(S, 1, i);
  Result:=S;
end;

end.
 